@use "sass:color";
@use "sass:map";

@import "./red-zoom-styles/base.scss";
@import "./red-zoom-styles/style-window.scss";
@import "@angular/cdk/overlay-prebuilt.css";

@import url('https://fonts.googleapis.com/css2?family=Rubik:wght@300;400;500;700&display=swap');

@import "~bootstrap/scss/functions";
@import "./pet-colors.scss";

@import "~bootstrap/scss/variables";
$theme-colors: map.merge($theme-colors, map.merge($pet-custom-colors, $pet-derived-colors));
$colors: map.merge($colors, $pet-element-specific-colors);

@import "./bootstrap-modules.scss";

@import "./pet-utilities.scss";

@import "./pet-glows.scss";
@import "./pet-borders.scss";

/* Bootstrap native classes customizations */

* {
	font-family: Rubik;
}

.host3d {
	perspective: 1000px
}

.card-body {
	@extend .card-body;
	color: var(--bs-main-gray);
}

label {
	font-weight: 500;
}

button, a.pet-nav-button {
	font-weight: 500 !important;
	color: var(--bs-tertiary-light) !important;
}

.pet-main-gradient {
	background: linear-gradient(150deg, var(--bs-tertiary) 20%, var(--bs-secondary-dark) 85%); 
}

.pet-primary-gradient {
	background: linear-gradient(90deg,
    var(--bs-primary-lighter) 0%, var(--bs-primary-lightest) 30%, var(--bs-primary-lightest) 70%, var(--bs-primary-lighter) 100%
  ); 
}

.pet-pill {
	@extend .bg-secondary; 
	@extend .rounded-pill; 
	@extend .d-inline-flex; 
	@extend .align-items-center;
	@extend .text-center; 
	@extend .border-secondary-dark; 
//	@extend .pet-glow-secondary; 
	@extend .text-tertiary-light;
	@extend .px-2;
	@extend .py-1;
	line-height: 1;
	max-width: 90vw;
	white-space: pre-wrap;
}

.striped-grid {
	
	&:nth-of-type(odd) {
		background-color: var(--bs-grid-light-stripe);
	}
	&:nth-of-type(even) {
		background-color: var(--bs-grid-dark-stripe);
	}
}

.striped-grid-rev {
	
	&:nth-of-type(odd) {
		background-color: var(--bs-grid-dark-stripe);
	}
	&:nth-of-type(even) {
		background-color: var(--bs-grid-light-stripe);
	}
}

.striped-grid-nested {
	
	&:nth-of-type(odd) .striped-item {
		background-color: var(--bs-grid-light-stripe);
	}
	&:nth-of-type(even) .striped-item {
		background-color: var(--bs-grid-dark-stripe);
	}
}

.shadow-in {
	box-shadow: 0 0.125rem 0.125rem -0.075rem inset rgba(0, 0, 0, 0.075) !important;
}

.hide-over-lg {
	@include media-breakpoint-up(lg) {
		display: none !important;
	}
}

.hide-until-lg {
	@include media-breakpoint-down(lg) {
		display: none !important;
	}
}

//.btn-xs {
//	@include button-size(($btn-padding-y-sm)*0.4, ($btn-padding-x-sm)*0.4, ($btn-font-size-sm)*0.8, ($btn-line-height-sm)*0.6, ($btn-border-radius-sm)*0.8);
//}

.dark-svg > svg > path {
	fill: var(--bs-tertiary-dark);
	stroke: var(--bs-tertiary-light);
	stroke-width: 20;
}

.light-svg > svg > path {
	fill: var(--bs-tertiary-light);
	stroke: var(--bs-tertiary-dark);	
	stroke-width: 20;
}

.dark-help-svg > svg > path {
	fill: var(--bs-info-dark);
	stroke: var(--bs-info);
	stroke-width: 20;
}

.light-help-svg > svg > path {
	fill: var(--bs-info);
	stroke: var(--bs-info-dark);
	stroke-width: 20;
}

.cdk-overlay-container {
	z-index: $zindex-tooltip;
	@extend .glowy-theme;
}

.pet-tooltip-panel {
	background-color: $tooltip-panel-color;
	@extend .p-1;
	@extend .rounded;
	@extend	.border;
	@extend .border-secondary-light;
	@extend .text-cool-white;
	@extend .text-center;

  & > .tooltip-inner {
  	position: relative;
  	background-color: $tooltip-inner-color;
  	border-radius: 0.25rem !important;
  }
  
  & > .tooltip-arrow {
    display: none;
  }
}

.pet-help-panel {
	@extend .card; 
	@extend .h-100; 
	@extend .justify-content-end; 
	@extend .rounded;
	@extend .bg-light;
	@extend .border-info-light;
//	@extend .glow-info;
}

.spinner-backdrop {
	background-color: var(--bs-spinner-backdrop-color);
}

.pet-text-clip {
	@extend .text-nowrap;
	@extend .overflow-hidden;
}


/* _border-width-customs.scss */
$border-width-custom-1: 1px !default;
$border-width-custom-2: 2px !default;
$border-width-custom-3: 3px !default;

$border-width-customs: ("1": $border-width-custom-1, "2": $border-width-custom-2, "3": $border-width-custom-3);

@each $name, $size in $border-width-customs {
	@each $var in '', 'top-', 'right-', 'bottom-', 'left-' {
		.border-#{$var}#{$name} { border-#{$var}width: $size !important; border-#{$var}style: solid; border-#{$var}color: $border-color;}
	}
}


/* Customizing ngb-paginator controls rendering */

ul.pagination {
  margin-bottom: 0;
}

.page-item.active .page-link {
	background-color: var(--bs-primary-dark);
	border-color: var(--bs-primary-fluo);
	color: var(--bs-tertiary-light);
	font-weight: 600;
	
	&:hover {
		background-color: var(--bs-primary-dark);
	}
	
	&:focus {
		box-shadow: none;
	}
}

.page-item .page-link {
	background-color: var(--bs-primary);
	border-color: var(--bs-primary-fluo);
	color: var(--bs-tertiary-light);
	font-weight: 600;
	
	&:hover {
		background-color: var(--bs-primary-light);
	}
	
	&:focus {
		box-shadow: none;
	}
}

/* Preserve line breaks and newline. Useful for code localized strings */
.pre-line {
	white-space: pre-line;	
}


/* Styling TypeAhaed suggestions panel */
ngb-typeahead-window {
	
	background-color: var(--bs-secondary-light) !important;
	
	& .dropdown-item.active {
		background-color: var(--bs-secondary);
	}
}


/* Disable Bootstrap outline and box-shadow on press */
.btn {
	
	&:active {
		//outline: none !important;
		box-shadow: none !important;
	}
	
	&:disabled {
		box-shadow: none !important
	}
}


